import{s as _e,o as Te,n as ge}from"../chunks/scheduler.c57aa7ef.js";import{S as ve,i as ye,g as r,s as a,r as C,A as be,h as c,f as i,c as n,j as he,u as A,x as p,k as we,y as Le,a as l,v as E,d as R,t as F,w as q}from"../chunks/index.394f8801.js";import{T as $e}from"../chunks/Tip.23dfb1a9.js";import{H as ie,E as Me}from"../chunks/EditOnGithub.157fddbf.js";function Pe(I){let o,d="Unless indicated otherwise, the default <code>torch.compile</code> settings were used.";return{c(){o=r("p"),o.innerHTML=d},l(s){o=c(s,"P",{"data-svelte-h":!0}),p(o)!=="svelte-11mpuzm"&&(o.innerHTML=d)},m(s,m){l(s,o,m)},p:ge,d(s){s&&i(o)}}}function He(I){let o,d="If you have another use case where you know that <code>torch.compile</code> does or does not work with PEFT, please contribute by letting us know or by opening a PR to add this use case to the covered test cases.";return{c(){o=r("p"),o.innerHTML=d},l(s){o=c(s,"P",{"data-svelte-h":!0}),p(o)!=="svelte-fo45pn"&&(o.innerHTML=d)},m(s,m){l(s,o,m)},p:ge,d(s){s&&i(o)}}}function xe(I){let o,d,s,m,h,z,w,le='In PEFT, <a href="https://pytorch.org/tutorials/intermediate/torch_compile_tutorial.html" rel="nofollow">torch.compile</a> works for some but not all features. The reason why it won’t always work is because PEFT is highly dynamic in certain places (loading and switching between multiple adapters, for instance), which can cause trouble for <code>torch.compile</code>. In other places, <code>torch.compile</code> may work, but won’t be as fast as expected because of graph breaks.',B,$,oe="If you don’t see an error, it doesn’t necessarily mean that <code>torch.compile</code> worked correctly. It might give you an output, but the output is incorrect. This guide describes what works with <code>torch.compile</code> and what doesn’t. For your own testing, we recommend using the latest PyTorch version, as <code>torch.compile</code> is constantly being improved.",G,f,O,g,S,_,ae="These features <strong>work</strong> with <code>torch.compile</code>. Everything listed below was tested with a causal LM:",j,T,ne="<li>Training with <code>Trainer</code> from 🤗 transformers</li> <li>Training with a custom PyTorch loop</li> <li>Inference</li> <li>Generation</li>",D,v,se="The following adapters were tested successfully:",K,y,re="<li>AdaLoRA</li> <li>BOFT</li> <li>Bone</li> <li>IA³</li> <li>Layer Norm Tuning</li> <li>LoHa</li> <li>LoKr</li> <li>LoRA</li> <li>LoRA + DoRA</li> <li>LoRA applied to embedding layers</li> <li>OFT</li> <li>VeRA</li> <li>HRA</li>",N,b,V,L,ce="Below are some of the more advanced PEFT features that <strong>work</strong>. They were all tested with LoRA.",J,M,pe="<li><code>modules_to_save</code> (i.e. <code>config = LoraConfig(..., modules_to_save=...)</code>)</li> <li>Merging adapters (one or multiple)</li> <li>Merging multiple adapters into one adapter (i.e. calling <code>model.add_weighted_adapter(...)</code>)</li> <li>Using PEFT adapters with quantization (bitsandbytes)</li> <li>Disabling adapters (i.e. using <code>with model.disable_adapter()</code>)</li> <li>Unloading (i.e. calling <code>model.merge_and_unload()</code>)</li> <li>Mixed adapter batches (i.e. calling <code>model(batch, adapter_names=[&quot;__base__&quot;, &quot;default&quot;, &quot;other&quot;, ...])</code>)</li> <li>Inference with multiple adapters (i.e. using <code>model.add_adapter</code> or <code>model.load_adapter</code> to load more than 1 adapter); for this, only call <code>torch.compile</code> <em>after</em> loading all adapters</li>",Q,P,de="Generally, we can expect that if a feature works correctly with LoRA and is also supported by other adapter types, it should also work for that adapter type.",W,H,X,x,me='All the use cases listed above are tested inside of <a href="https://github.com/huggingface/peft/blob/main/tests/test_torch_compile.py" rel="nofollow"><code>peft/tests/test_torch_compile.py</code></a>. If you want to check in more detail how we tested a certain feature, please go to that file and check the test that corresponds to your use case.',Y,u,Z,k,ee,U,te;return h=new ie({props:{title:"torch.compile",local:"torchcompile",headingTag:"h1"}}),f=new $e({props:{warning:!1,$$slots:{default:[Pe]},$$scope:{ctx:I}}}),g=new ie({props:{title:"Training and inference with torch.compile",local:"training-and-inference-with-torchcompile",headingTag:"h2"}}),b=new ie({props:{title:"Advanced PEFT features with torch.compile",local:"advanced-peft-features-with-torchcompile",headingTag:"h2"}}),H=new ie({props:{title:"Test cases",local:"test-cases",headingTag:"h2"}}),u=new $e({props:{warning:!1,$$slots:{default:[He]},$$scope:{ctx:I}}}),k=new Me({props:{source:"https://github.com/huggingface/peft/blob/main/docs/source/developer_guides/torch_compile.md"}}),{c(){o=r("meta"),d=a(),s=r("p"),m=a(),C(h.$$.fragment),z=a(),w=r("p"),w.innerHTML=le,B=a(),$=r("p"),$.innerHTML=oe,G=a(),C(f.$$.fragment),O=a(),C(g.$$.fragment),S=a(),_=r("p"),_.innerHTML=ae,j=a(),T=r("ul"),T.innerHTML=ne,D=a(),v=r("p"),v.textContent=se,K=a(),y=r("ul"),y.innerHTML=re,N=a(),C(b.$$.fragment),V=a(),L=r("p"),L.innerHTML=ce,J=a(),M=r("ul"),M.innerHTML=pe,Q=a(),P=r("p"),P.textContent=de,W=a(),C(H.$$.fragment),X=a(),x=r("p"),x.innerHTML=me,Y=a(),C(u.$$.fragment),Z=a(),C(k.$$.fragment),ee=a(),U=r("p"),this.h()},l(e){const t=be("svelte-u9bgzb",document.head);o=c(t,"META",{name:!0,content:!0}),t.forEach(i),d=n(e),s=c(e,"P",{}),he(s).forEach(i),m=n(e),A(h.$$.fragment,e),z=n(e),w=c(e,"P",{"data-svelte-h":!0}),p(w)!=="svelte-1epca12"&&(w.innerHTML=le),B=n(e),$=c(e,"P",{"data-svelte-h":!0}),p($)!=="svelte-ekv2oq"&&($.innerHTML=oe),G=n(e),A(f.$$.fragment,e),O=n(e),A(g.$$.fragment,e),S=n(e),_=c(e,"P",{"data-svelte-h":!0}),p(_)!=="svelte-10kwh8m"&&(_.innerHTML=ae),j=n(e),T=c(e,"UL",{"data-svelte-h":!0}),p(T)!=="svelte-1bf32c1"&&(T.innerHTML=ne),D=n(e),v=c(e,"P",{"data-svelte-h":!0}),p(v)!=="svelte-1u6npfd"&&(v.textContent=se),K=n(e),y=c(e,"UL",{"data-svelte-h":!0}),p(y)!=="svelte-1hk6m6j"&&(y.innerHTML=re),N=n(e),A(b.$$.fragment,e),V=n(e),L=c(e,"P",{"data-svelte-h":!0}),p(L)!=="svelte-gy3aka"&&(L.innerHTML=ce),J=n(e),M=c(e,"UL",{"data-svelte-h":!0}),p(M)!=="svelte-142zgr"&&(M.innerHTML=pe),Q=n(e),P=c(e,"P",{"data-svelte-h":!0}),p(P)!=="svelte-x3yaa4"&&(P.textContent=de),W=n(e),A(H.$$.fragment,e),X=n(e),x=c(e,"P",{"data-svelte-h":!0}),p(x)!=="svelte-1ks3zgv"&&(x.innerHTML=me),Y=n(e),A(u.$$.fragment,e),Z=n(e),A(k.$$.fragment,e),ee=n(e),U=c(e,"P",{}),he(U).forEach(i),this.h()},h(){we(o,"name","hf:doc:metadata"),we(o,"content",ke)},m(e,t){Le(document.head,o),l(e,d,t),l(e,s,t),l(e,m,t),E(h,e,t),l(e,z,t),l(e,w,t),l(e,B,t),l(e,$,t),l(e,G,t),E(f,e,t),l(e,O,t),E(g,e,t),l(e,S,t),l(e,_,t),l(e,j,t),l(e,T,t),l(e,D,t),l(e,v,t),l(e,K,t),l(e,y,t),l(e,N,t),E(b,e,t),l(e,V,t),l(e,L,t),l(e,J,t),l(e,M,t),l(e,Q,t),l(e,P,t),l(e,W,t),E(H,e,t),l(e,X,t),l(e,x,t),l(e,Y,t),E(u,e,t),l(e,Z,t),E(k,e,t),l(e,ee,t),l(e,U,t),te=!0},p(e,[t]){const fe={};t&2&&(fe.$$scope={dirty:t,ctx:e}),f.$set(fe);const ue={};t&2&&(ue.$$scope={dirty:t,ctx:e}),u.$set(ue)},i(e){te||(R(h.$$.fragment,e),R(f.$$.fragment,e),R(g.$$.fragment,e),R(b.$$.fragment,e),R(H.$$.fragment,e),R(u.$$.fragment,e),R(k.$$.fragment,e),te=!0)},o(e){F(h.$$.fragment,e),F(f.$$.fragment,e),F(g.$$.fragment,e),F(b.$$.fragment,e),F(H.$$.fragment,e),F(u.$$.fragment,e),F(k.$$.fragment,e),te=!1},d(e){e&&(i(d),i(s),i(m),i(z),i(w),i(B),i($),i(G),i(O),i(S),i(_),i(j),i(T),i(D),i(v),i(K),i(y),i(N),i(V),i(L),i(J),i(M),i(Q),i(P),i(W),i(X),i(x),i(Y),i(Z),i(ee),i(U)),i(o),q(h,e),q(f,e),q(g,e),q(b,e),q(H,e),q(u,e),q(k,e)}}}const ke='{"title":"torch.compile","local":"torchcompile","sections":[{"title":"Training and inference with torch.compile","local":"training-and-inference-with-torchcompile","sections":[],"depth":2},{"title":"Advanced PEFT features with torch.compile","local":"advanced-peft-features-with-torchcompile","sections":[],"depth":2},{"title":"Test cases","local":"test-cases","sections":[],"depth":2}],"depth":1}';function Ce(I){return Te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends ve{constructor(o){super(),ye(this,o,Ce,xe,_e,{})}}export{qe as component};
